# Created by pyp2rpm-3.3.5
%if 0%{?rhel}
%bcond_with docs
%else
%bcond_without docs
%endif
%bcond_without tests

%global pypi_name drgn

%global _description %{expand:
drgn (pronounced "dragon") is a debugger with an emphasis on programmability.
drgn exposes the types and variables in a program for easy, expressive
scripting in Python.}

Name:           python-%{pypi_name}
Version:        0.0.26+102.gb7f6d913
Release:        1.20240625155334414186.pr409.102.gb7f6d913%{?dist}
Summary:        Programmable debugger

License:        LGPL-2.1-or-later
URL:            https://github.com/osandov/drgn
Source0:        drgn-0.0.26+102.gb7f6d913.tar.gz

BuildRequires:  python3-devel
BuildRequires:  python3dist(setuptools)
%if %{with docs}
BuildRequires:  sed
BuildRequires:  python3dist(sphinx)
BuildRequires:  python3-docs
%endif
%if %{with tests}
BuildRequires:  python3dist(pytest)
%endif
BuildRequires:  gcc-c++
BuildRequires:  make
BuildRequires:  bzip2-devel
BuildRequires:  elfutils-devel
BuildRequires:  libkdumpfile-devel
BuildRequires:  zlib-devel
BuildRequires:  xz-devel
# These are needed when building from git snapshots
BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  libtool

%description %{_description}

%package -n     %{pypi_name}
Summary:        %{summary}

%description -n %{pypi_name} %{_description}

%if %{with docs}
%package -n %{pypi_name}-doc
Summary:        %{pypi_name} documentation
BuildArch:      noarch
Requires:       python3-docs

%description -n %{pypi_name}-doc %{_description}

This package contains additional documentation for %{pypi_name}.
%endif

%prep
%autosetup -n drgn-0.0.26+102.gb7f6d913 -p1
# Remove bundled egg-info
rm -rf %{pypi_name}.egg-info
%if %{with docs}
# Use local intersphinx inventory
sed -r \
    -e 's|https://docs.python.org/3|%{_docdir}/python3-docs/html|' \
    -i docs/conf.py
%endif
# Ensure version is always set, even when building from git snapshots
if [ ! -f drgn/internal/version.py ]; then
  echo '__version__ = "%{version}"' > drgn/internal/version.py
fi

%build
# verbose build
V=1 %py3_build

%if %{with docs}
# generate html docs
PYTHONPATH=${PWD} sphinx-build-3 docs html
# remove the sphinx-build leftovers
rm -rf html/.{doctrees,buildinfo}
%endif

%install
%py3_install
mkdir -p %{buildroot}%{_datadir}/drgn
cp -PR contrib tools %{buildroot}%{_datadir}/drgn

%if %{with tests}
%check
%pytest
%endif

%files -n %{pypi_name}
%license COPYING
%license LICENSES
%doc README.rst
%{_bindir}/drgn
%{_datadir}/drgn
%{python3_sitearch}/_%{pypi_name}.pyi
%{python3_sitearch}/_%{pypi_name}.cpython*.so
%{python3_sitearch}/%{pypi_name}
%{python3_sitearch}/%{pypi_name}-%{version}-py%{python3_version}.egg-info

%if %{with docs}
%files -n %{pypi_name}-doc
%license COPYING
%license LICENSES
%doc html
%endif

%changelog
* Tue Jun 25 2024 Packit <hello@packit.dev> - 0.0.26+102.gb7f6d913-1.20240625155334414186.pr409.102.gb7f6d913
- contrib/bpf_inspect.py: disas bpf prog with capstone (Leon Hwang)
- contrib/bpf_inspect.py: show subprogs of prog (Leon Hwang)
- contrib/bpf_inspect.py: show used maps of prog (Leon Hwang)
- scripts/build_manylinux_in_docker.sh: use pytest instead of setup.py test (Omar Sandoval)
- libdrgn: kdump: fix build with libkdumpfile < 0.4.1 (Omar Sandoval)
- contrib/bpf_inspect.py: inspect map details (Leon Hwang)
- contrib/bpf_inspect.py: fix get tramp progs (Leon Hwang)
- contrib/bpf_inspect.py: show interface info for XDP link (Leon Hwang)
- contrib/bpf_inspect.py: show tail_call_reachable (Leon Hwang)
- contrib/bpf_inspect.py: abstract bpf classes (Leon Hwang)
- drgn.helpers.common.memory: add optional cache to identify_address() (Omar Sandoval)
- libdrgn: fix stray double semicolon (Omar Sandoval)
- Update trove classifiers (Stephen Brennan)
- libdrgn: enable -Wshadow (Omar Sandoval)
- Convert scripts/test_cityhash.c to C unit test (Omar Sandoval)
- libdrgn: enable -Wpointer-arith (Omar Sandoval)
- contrib/bpf_inspect.py: inspect linked progs (Leon Hwang)
- libdrgn: get initial registers for kdump from crash_notes variable (Omar Sandoval)
- libdrgn: factor out ELF note parsing (Omar Sandoval)
- drgn.helpers.linux.mm: comment that vmap_nodes workaround also applies to !SMP (Omar Sandoval)
- vmtest.config: enable CONFIG_FW_CFG_SYSFS for testing QEMU dump-guest-memory (Omar Sandoval)
- tests: require full MM support for print_annotated_memory() test (Omar Sandoval)
- helpers.linux.mm: work around optimized out vmap_nodes on 32-bit (Omar Sandoval)
- vmtest.__main__: use correct Python executable when emulating (Omar Sandoval)
- vmtest.vm: add --{build,insert}-test-kmod options (Omar Sandoval)
- Add 6.10 to supported kernels (Omar Sandoval)
- drgn.helpers.linux.mm: update PageSlab() for Linux 6.10 (Omar Sandoval)
- drgn.helpers.linux.block: add bdev_partno() helper to fix for_each_disk() for Linux 6.10 (Omar Sandoval)
- README: make badges inline on GitHub again (Omar Sandoval)
- Allow naming and configuring order of object finders (Omar Sandoval)
- libdrgn: linux_kernel: deduplicate kernel-specific program setup (Omar Sandoval)
- Allow naming and configuring order of type finders (Omar Sandoval)
- python: add TypeKindSet (Omar Sandoval)
- Allow naming and configuring order of symbol finders (Omar Sandoval)
- libdrgn: add interface for registering chains of named handlers (Omar Sandoval)
- drgndoc: fix formatting chains of attribute accesses (Omar Sandoval)
- libdrgn: python: don't construct unnecessary tuple for add_object_finder() (Omar Sandoval)
- libdrgn: python: set Python error indicator if Program_hold_object() fails (Omar Sandoval)
- libdrgn: x86_64: avoid recursive address translation for swapper_pg_dir (Stephen Brennan)
- libdrgn: add libkdumpfile RISC-V support (Stephen Brennan)
- libdrgn: kdump: pass architecture and vmcoreinfo to libkdumpfile (Stephen Brennan)
- cli: support manually specifying architecture and vmcoreinfo data (Stephen Brennan)
- python: Allow specifying vmcoreinfo at Program creation (Stephen Brennan)
- libdrgn: respect present vmcoreinfo in set_core_dump() (Stephen Brennan)
- contrib/bpf_inspect.py: list bpf links (Leon Hwang)
- contrib/lsmod.py: update for Linux 6.4 (Omar Sandoval)
- contrib/bpf_inspect.py: hide args from interactive mode (Leon Hwang)
- Fix CI failure on Python 3.12 (Stephen Brennan)
- packit: replace EPEL 9 with centos-stream+epel-next-9 and c9s-build (Michel Lind)
- contrib/bpf_inspect.py: add interactive mode (Leon Hwang)
- contrib/btrfs_tree.py: fix extra whitespace when printing inode item (Omar Sandoval)
- packit: disable EPEL 9 builds (Omar Sandoval)
- contrib: add negdentdelete.py script (Stephen Brennan)
- contrib/btrfs_tree.py: flesh out structures and helpers (Omar Sandoval)
- contrib/gcore.py: fix vma offset handling (Omar Sandoval)
- contrib: add script to extract process core dump from kernel (Omar Sandoval)
- libdrgn: examples: load_debug_info: fix build due to headers not being found (Omar Sandoval)
- libdrgn: stack_trace: get DW_AT_frame_base from containing DW_TAG_subprogram DIE (Omar Sandoval)
- vmtest.vm: don't try updating /etc/mtab from umount (Omar Sandoval)
- libdrgn: python: set Python error indicator if Program_hold_reserve() fails (Omar Sandoval)
- Translate path_iterator tests to C unit tests (Omar Sandoval)
- Translate C lexer tests to C unit tests (Omar Sandoval)
- Translate tests/test_lexer.py to C unit test (Omar Sandoval)
- Add scaffolding for libdrgn C unit tests (Omar Sandoval)
- libdrgn: pp: add PP_MAP() to call a macro on each variable argument (Omar Sandoval)
- libdrgn: pp: make PP_NARGS() expand to 0 (Omar Sandoval)
- Add Symbol constructor type annotation and documentation (Omar Sandoval)
- libdrgn: hash_table: fix compilation error on old GCC (Omar Sandoval)
- setup.py: flush stdout and stderr before GitHub Actions grouping commands (Omar Sandoval)
- helpers.linux.stackdepot: update stack_depot_fetch() for Linux 6.9 and 6.8.5, take 2 (Omar Sandoval)
- Revert "helpers.linux.stackdepot: update stack_depot_fetch() for Linux 6.9 and 6.8.2" (Omar Sandoval)
- libdrgn: hash_table: port table size reduction (Omar Sandoval)
- libdrgn: hash_table: prefetch the right thing when rehashing (Omar Sandoval)
- libdrgn: hash_table: limit maximum size correctly (Omar Sandoval)
- libdrgn: hash_table: replace zero-length array hack with typedef_if (Omar Sandoval)
- libdrgn: vector: fix vector_max_size (Omar Sandoval)
- tests: fix -Wmissing-prototypes warning in drgn_test kmod (Omar Sandoval)
- tests: test member_at_offset() on padding in nested structs/array elements (Omar Sandoval)
- helpers.common.type: add member_at_offset() helper (Omar Sandoval)
- libdrgn: make include paths stricter (Omar Sandoval)
- libdrgn/python: fix #includes in symbol.c (Omar Sandoval)
- contrib/search_kernel_memory.py: translate vmap addresses (Omar Sandoval)
- helpers.common.memory: recognize vmap stacks in identify_address() (Omar Sandoval)
- helper.common.memory: recognize vmap addresses in identify_address() (Omar Sandoval)
- helpers.linux.mm: add find_vmap_area() and for_each_vmap_area() (Omar Sandoval)
- helpers.common.memory: add print_annotated_memory() helper (Omar Sandoval)
- Add 6.9 to supported kernels (Omar Sandoval)
- helpers.linux.stackdepot: update stack_depot_fetch() for Linux 6.9 and 6.8.2 (Omar Sandoval)
- Add "Getting Help" section to README and docs main page (Omar Sandoval)
- Revert "vmtest.manage: work around broken 5.10 stable build" (Omar Sandoval)
- contrib: add script to search kernel memory (Omar Sandoval)
- tests: add infrastructure for test resources (Omar Sandoval)
- contrib/irq: fix for v6.5 and later kernels. (Imran Khan)
- libdrgn: ppc64: use DRGN_ERROR_NOT_IMPLEMENTED when virtual address translation is not supported (Omar Sandoval)
- Add test for Symbol Finder API (Stephen Brennan)
- python: Add Program.add_symbol_finder() (Stephen Brennan)
- python: Allow construction of Symbol objects (Stephen Brennan)
- libdrgn: move elf_symbols_search to debug_info.c (Stephen Brennan)
- libdrgn: Use Symbol Finder API in find_symbol_by_address_internal() (Stephen Brennan)
- libdrgn: move find_symbol_by_address_internal (Stephen Brennan)
- libdrgn: introduce Symbol Finder API (Stephen Brennan)
- libdrgn: shrink symbol binding & kind enums (Stephen Brennan)
